/**
 * Factory of node classes.
 *
 * @CLIENT_SERVER
 */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var 
NodeFactory = (function () {





  function NodeFactory() {_classCallCheck(this, NodeFactory);
    this._nodeTypes = {};}


  /**
   * @param {Array<Array<any>>} nodeConfigArray
   * @return {Array<Node>}
   */_createClass(NodeFactory, [{ key: 'createFromConfig', value: 
    function createFromConfig(nodeConfigArray) {
      var i, nodes = [];
      for (i = 0; i < nodeConfigArray.length; i++) {
        nodes = nodes.concat(this.create(nodeConfigArray[i]));}

      return nodes;}


    /**
     * @param {Array<any>} nodeConfig
     * @return {Array<Node>}
     */ }, { key: 'create', value: 
    function create(nodeConfig) {
      if (nodeConfig.length < 1) {
        throw new Error('Route configuration contains node with no name!');}

      var nodeName = nodeConfig.slice(0, 1)[0];
      nodeConfig = nodeConfig.slice(1);
      var nodeClass = this._nodeTypes[nodeName];
      if (!nodeClass) {
        throw new Error('Route configuration contains unregistered node: ' + nodeName + '.');}

      var result = nodeClass.constructFromConfig(nodeConfig);
      return result;}


    /**
     * @param {Function} nodeClass
     */ }, { key: 'registerNodeType', value: 
    function registerNodeType(nodeClass) {
      if (!nodeClass.nodeName) {
        throw new Error('Given Node class doesn\'t have static nodeName property: ' + nodeClass + '.');}

      if (this._nodeTypes.hasOwnProperty(nodeClass.nodeName)) {
        throw new Error('Clash in node name: ' + nodeClass.nodeName);}


      this._nodeTypes[nodeClass.nodeName] = nodeClass;} }]);return NodeFactory;})();exports['default'] = NodeFactory;module.exports = exports['default']; /**
                                                                                                                                                           * @type {{[key: string]: Function}}
                                                                                                                                                           */
//# sourceMappingURL=NodeFactory.js.map